'From Squeak3.1beta of 14 November 2001 [latest update: #4478] on 28 November 2001 at 9:42:07 am'!
"Change Set:		Hook-MW3.1
Date:			26 November 2001
Author:			sd

Introduce a first set of hook methods in the class CodeBalloonMorph. 

Second iteration introduce a MorphicWrapper configuration
so that we can modify the font, classes....of the morphicwrapper. This may be too complex we will see in the future.

There is two way of customising the morphic wrapper or you create new configuration or you subclass CodeBalloonMorph and CodeStringMorph.
"!

Object subclass: #MorphicWrapperConfiguration
	instanceVariableNames: 'codeStringMorphClass codeBalloonMorphClass defaultFont defaultContents defaultColor defaultBorderWidth defaultBorderColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!

!MorphicWrapperConfiguration commentStamp: 'sd 11/26/2001 23:00' prior: 0!
I represent some defaults value such as the color of the balloon code and other things like that that we do not want to spread in pasteUpMorph and other beasts!

MorphicWrapperConfiguration class
	instanceVariableNames: 'uniqueInstance '!

!CodeBalloonMorph class methodsFor: 'instance creation' stamp: 'sd 11/27/2001 17:39'!
code: str for: morph corner: cornerName 

	
	"Make up and return a balloon for morph.  Find the quadrant 
  

	that clips the text the least, using cornerName as a tie-breaker."

	

	(str isKindOf: EditableStringMorph)

		
		ifTrue: [str focusBackColor: Color transparent].

	
	^ self new color: self color;

	 
		setBorderWidth: self borderWidth borderColor: self borderColor;

	 
		setTarget: morph;

	 
		setCornerName: cornerName;

	 
		addMorph: str! !

!CodeBalloonMorph class methodsFor: 'instance creation' stamp: 'sd 11/27/2001 15:56'!
for: target hand: hnd 

	
	| text balloon |

	
	text _ self codeStringMorphClass new 
					contents: self contents ; 
					font: self font.	
	balloon _ self

code: text

	for: hnd

corner: #buttomRight.

	
	text privateHasFocus: true;

	 
		bindings: hnd world bindings;

	 
		target: target;

	 
		actionSelector: #acceptBalloon:;

	 
		arguments: (Array with: balloon);

	 
		history: (hnd world historyFor: target).


	hnd grabMorph: balloon;

	 
		newKeyboardFocus: balloon.

	
	^ balloon! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
borderColor

	"^ Color black"
	^ MorphicWrapperConfiguration uniqueInstance borderColor! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
borderWidth

	"^ 1"
	^ MorphicWrapperConfiguration uniqueInstance borderWidth! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
codeStringMorphClass

	"^  CodeStringMorph"
	^ MorphicWrapperConfiguration uniqueInstance codeStringMorphClass! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 16:14'!
color

	"^ (Color

r: 1.0

g: 1.0

b: 0.6)"
	^ MorphicWrapperConfiguration uniqueInstance color! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
contents

	"^  ''"
	^ MorphicWrapperConfiguration uniqueInstance contents! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:53'!
font

	"BalloonMorph balloonFont"
	^ MorphicWrapperConfiguration uniqueInstance font	! !


!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
borderColor

	^ defaultBorderColor ! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:55'!
borderColor: aColor

	 defaultBorderColor := aColor! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
borderWidth

	^ defaultBorderWidth ! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
borderWidth: anInteger

	defaultBorderWidth := anInteger! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeBalloonMorphClass

	^ codeBalloonMorphClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeBalloonMorphClass: aClass

	codeBalloonMorphClass := aClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeStringMorphClass

	^ codeStringMorphClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeStringMorphClass: aClass

	codeStringMorphClass := aClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
color

	^ defaultColor! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:57'!
color: aColor

	defaultColor := aColor! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:10'!
contents

	^ defaultContents! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:09'!
contents: aString

	defaultContents := aString! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:44'!
defaultContents

	^ defaultContents! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:44'!
defaultContents: aString

	defaultContents := aString! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:33'!
defaultFont

	^ defaultFont! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:33'!
defaultFont: aFont

	defaultFont := aFont! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:12'!
font

	^ defaultFont! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:12'!
font: aFont

	defaultFont := aFont! !

!MorphicWrapperConfiguration methodsFor: 'initialize' stamp: 'sd 11/27/2001 17:35'!
initialize
	
	self codeStringMorphClass: CodeStringMorph.
	self codeBalloonMorphClass: CodeBalloonMorph.
	self font: BalloonMorph balloonFont.
	self contents: ''.
	self color: (Color

r: 1.0

g: 1.0

b: 0.6).
	self borderWidth: 1.
	self borderColor: (Color black).! !


!MorphicWrapperConfiguration class methodsFor: 'example' stamp: 'sd 11/28/2001 09:41'!
changeToGetANiceStyle
	"self changeToGetANiceStyle"

	MorphicWrapperConfiguration uniqueInstance
		font: (StrikeFont familyName: #ComicPlain size: 24) ;
		contents: '  ';
		color: ((Color r: 1.0 g: 1.0 b: 0.6) alpha: 0.8); 	
		borderColor: (Color r: 1 g: 0.2 b: 0.2)
	! !

!MorphicWrapperConfiguration class methodsFor: 'instance creation' stamp: 'sd 11/26/2001 22:59'!
new

	self error: 'use unique instance to get an instance'! !

!MorphicWrapperConfiguration class methodsFor: 'instance creation' stamp: 'sd 11/27/2001 17:39'!
reset
	"self reset"

	uniqueInstance := nil! !

!MorphicWrapperConfiguration class methodsFor: 'instance creation' stamp: 'sd 11/26/2001 22:59'!
uniqueInstance

	uniqueInstance isNil
		ifTrue: [uniqueInstance := self basicNew initialize].
	^ uniqueInstance! !


!PasteUpMorph methodsFor: 'aerial typing' stamp: 'sd 11/26/2001 23:05'!
aerialKeystroke: evt 
	| targetMorph balloon |
	targetMorph _ self targetFor: evt.
	evt keyCharacter = Character backspace
		ifTrue: [targetMorph slideToTrash: evt;
				 delete.
			^ self].
	balloon _ MorphicWrapperConfiguration uniqueInstance codeBalloonMorphClass for: targetMorph aerialTarget hand: evt hand.
	balloon keyStroke: evt! !

MorphicWrapperConfiguration removeSelector: #defaultBorderColor!
MorphicWrapperConfiguration removeSelector: #defaultBorderColor:!
MorphicWrapperConfiguration removeSelector: #defaultBorderWidth!
MorphicWrapperConfiguration removeSelector: #defaultBorderWidth:!
MorphicWrapperConfiguration removeSelector: #defaultBorderWith!
MorphicWrapperConfiguration removeSelector: #defaultColor!
MorphicWrapperConfiguration removeSelector: #defaultColor:!
CodeBalloonMorph class removeSelector: #defaultBorderColor!
CodeBalloonMorph class removeSelector: #defaultBorderWidth!
CodeBalloonMorph class removeSelector: #defaultCodeStringMorphClass!
CodeBalloonMorph class removeSelector: #defaultColor!
CodeBalloonMorph class removeSelector: #defaultContents!
CodeBalloonMorph class removeSelector: #defaultFont!
